<script setup lang="ts">
const props = defineProps<{ gene: string }>();
const { fetchOrthology } = useGeneService();

const { data, error, pending } = await useAsyncData(
  `orthologs-${props.gene}`,
  () => fetchOrthology(props.gene),
);

const sources = (data.value?.orthologs || []).reduce(
  (acc, o) => {
    if (o.source) {
      acc[o.gene] = [o.source, ...(acc[o.gene] || [])];
    }
    return acc;
  },
  {} as Record<string, string[]>,
);
const orthologousGenes = Object.entries(sources)
  .sort(([, a], [, b]) => b.length - a.length)
  .map(([gene]) => gene);
const selectedOrthologousGene = ref<string | null>(orthologousGenes[0] || null);
</script>

<template>
  <AsyncView
    :error="error"
    :loading="pending"
    :error-message="`Failed to fetch orthologs for gene ${$props.gene}`"
  >
    <v-row v-if="orthologousGenes.length > 0">
      <v-col cols="12" xl="7">
        <OrthologList
          v-model:selected="selectedOrthologousGene"
          :genes="orthologousGenes"
          :source-map="sources"
        />
      </v-col>
      <v-col>
        <OrthologGeneOntology
          v-model:selected="selectedOrthologousGene"
          :genes="orthologousGenes"
        />
      </v-col>
    </v-row>
    <NoDataText v-else class="pa-4">No fly homologs</NoDataText>
  </AsyncView>
</template>
